/* global.h 
*
* for ed2k_slist.c
*
*
* --- COPYRIGHT AND LICENCE ---
*
* Copyright (C) 2001 Tim-Philipp Mller (t.i.m@orange.net)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>

#define USEFUL 1
#define NOT_USEFUL 0

#define MAX_SERVERNAME_SIZE 260
#define MAX_NO_OF_SERVERS   1024

#define DEFAULT_TIMEOUT 25

struct donkeyserver {
  char           name [MAX_SERVERNAME_SIZE];
  char 		 ip_str [20];
  unsigned int   ip_int, users, files, ping;
  unsigned short port;
};

typedef struct donkeyserver donkeyserver;

void digest_server_file ();
int  get_next_known_server (FILE *, donkeyserver *);/* extracts next record from server.met      */
void digest_tag (FILE *, donkeyserver *);           /* digests tags in server.met for one record */
void print_donkeyserver_info (donkeyserver *);
void graceful_exit (char msg[1024]);                /* print message, free memory, and exit      */
void free_allocated_memory (void);                  /* free allocated memory                     */
void int_to_string (int n, char *n_str);
void int_to_string_with_dot (int n, char *n_str);
int does_server_connect (donkeyserver *dfp);        /* returns USEFUL if connect successful      */
void print_help (void);
void make_new_server_file (void);
void http_get_serverlist (void);

/* GLOBAL VARIABLES *************************************************************************/

donkeyserver   *known_table=NULL;           /* pointer to table of known.met donkeyserver records   */

unsigned int no_of_known_servers;           /* number of servers referenced in known.met            */
unsigned int no_of_useful_servers;          /* number of known servers that could be candidates     */

int          verbose = 1, htmloutput = 0;

int          known_server_useful     [MAX_NO_OF_SERVERS];
int          known_server_record_len [MAX_NO_OF_SERVERS];

unsigned int server_no;                     /* counter */
unsigned int server_record_len;

int 		 SERVER_TIMEOUT = DEFAULT_TIMEOUT;
